<?php

class MyPlainParser implements IPastebinParser
{
	public function parse($text)
	{
		return "<pre>\n" . htmlentities($text, ENT_COMPAT, 'UTF-8') . "</pre>\n";
	}
}

class MyPhpParser implements IPastebinParser
{
	public function parse($text)
	{
		$tokens = token_get_all($text);
		$out = "<pre>\n";
		foreach ($tokens as $token) {
			if (is_array($token)) {
				$out .= '<span class="' . token_name($token[0]) . '">' . $this->_e($token[1]) . '</span>';
			} else {
				if (trim($token) == '') {
					$out .= $token;
				} else {
					$out .= $this->_e($token);
				}
			}

		}
		$out .= "</pre>\n";
		return $out;
	}

	private function _e($s)
	{
		return htmlentities($s, ENT_COMPAT, 'UTF-8');
	}
}
